# This file is autogenerated
import threading
import ctypes
import os
from typing import Any



class Singleton(type):
    _instances = {} # type: ignore
    _lock = threading.Lock()

    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            with cls._lock:
                if cls not in cls._instances:
                    cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]


class NativeMethods(metaclass=Singleton):

    def init_dll(self, bin_location: str, bin_prefix: str, bin_ext: str):
        try:
            self.dll = ctypes.CDLL(os.path.join(bin_location, f'{bin_prefix}autd3capi_gain_holo{bin_ext}'))
        except FileNotFoundError:
            return

        self.dll.AUTDDefaultBackend.argtypes = [] 
        self.dll.AUTDDefaultBackend.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloSDP.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloSDP.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloSDPAlpha.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloSDPAlpha.restype = None

        self.dll.AUTDGainHoloSDPLambda.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloSDPLambda.restype = None

        self.dll.AUTDGainHoloSDPRepeat.argtypes = [ctypes.c_void_p, ctypes.c_uint32] 
        self.dll.AUTDGainHoloSDPRepeat.restype = None

        self.dll.AUTDGainHoloSDPAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloSDPAdd.restype = None

        self.dll.AUTDGainHoloSDPSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloSDPSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloSDPSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloSDPSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloSDPSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloSDPSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloSDPSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloSDPSetClampConstraint.restype = None

        self.dll.AUTDGainHoloEVP.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloEVP.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloEVPGamma.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloEVPGamma.restype = None

        self.dll.AUTDGainHoloEVPAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloEVPAdd.restype = None

        self.dll.AUTDGainHoloEVPSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloEVPSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloEVPSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloEVPSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloEVPSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloEVPSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloEVPSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloEVPSetClampConstraint.restype = None

        self.dll.AUTDGainHoloGS.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGS.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloGSRepeat.argtypes = [ctypes.c_void_p, ctypes.c_uint32] 
        self.dll.AUTDGainHoloGSRepeat.restype = None

        self.dll.AUTDGainHoloGSAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGSAdd.restype = None

        self.dll.AUTDGainHoloGSSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGSSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloGSSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGSSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloGSSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloGSSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloGSSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGSSetClampConstraint.restype = None

        self.dll.AUTDGainHoloGSPAT.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGSPAT.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloGSPATRepeat.argtypes = [ctypes.c_void_p, ctypes.c_uint32] 
        self.dll.AUTDGainHoloGSPATRepeat.restype = None

        self.dll.AUTDGainHoloGSPATAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGSPATAdd.restype = None

        self.dll.AUTDGainHoloGSPATSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGSPATSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloGSPATSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGSPATSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloGSPATSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloGSPATSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloGSPATSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGSPATSetClampConstraint.restype = None

        self.dll.AUTDGainHoloNaive.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloNaive.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloNaiveAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloNaiveAdd.restype = None

        self.dll.AUTDGainHoloNaiveSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloNaiveSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloNaiveSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloNaiveSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloNaiveSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloNaiveSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloNaiveSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloNaiveSetClampConstraint.restype = None

        self.dll.AUTDGainHoloGreedy.argtypes = [] 
        self.dll.AUTDGainHoloGreedy.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloGreedyPhaseDiv.argtypes = [ctypes.c_void_p, ctypes.c_uint32] 
        self.dll.AUTDGainHoloGreedyPhaseDiv.restype = None

        self.dll.AUTDGainHoloGreedyAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGreedyAdd.restype = None

        self.dll.AUTDGainHoloGreedySetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGreedySetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloGreedySetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloGreedySetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloGreedySetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloGreedySetUniformConstraint.restype = None

        self.dll.AUTDGainHoloGreedySetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloGreedySetClampConstraint.restype = None

        self.dll.AUTDGainHoloLM.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloLM.restype = ctypes.c_void_p

        self.dll.AUTDGainHoloLMEps1.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloLMEps1.restype = None

        self.dll.AUTDGainHoloLMEps2.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloLMEps2.restype = None

        self.dll.AUTDGainHoloLMTau.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloLMTau.restype = None

        self.dll.AUTDGainHoloLMKMax.argtypes = [ctypes.c_void_p, ctypes.c_uint32] 
        self.dll.AUTDGainHoloLMKMax.restype = None

        self.dll.AUTDGainHoloLMInitial.argtypes = [ctypes.c_void_p, ctypes.POINTER(ctypes.c_double), ctypes.c_uint64] 
        self.dll.AUTDGainHoloLMInitial.restype = None

        self.dll.AUTDGainHoloLMAdd.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloLMAdd.restype = None

        self.dll.AUTDGainHoloLMSetDotCareConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloLMSetDotCareConstraint.restype = None

        self.dll.AUTDGainHoloLMSetNormalizeConstraint.argtypes = [ctypes.c_void_p] 
        self.dll.AUTDGainHoloLMSetNormalizeConstraint.restype = None

        self.dll.AUTDGainHoloLMSetUniformConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double] 
        self.dll.AUTDGainHoloLMSetUniformConstraint.restype = None

        self.dll.AUTDGainHoloLMSetClampConstraint.argtypes = [ctypes.c_void_p, ctypes.c_double, ctypes.c_double] 
        self.dll.AUTDGainHoloLMSetClampConstraint.restype = None

    def default_backend(self) -> ctypes.c_void_p:
        return self.dll.AUTDDefaultBackend()

    def gain_holo_sdp(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloSDP(backend)

    def gain_holo_sdp_alpha(self, holo: ctypes.c_void_p, alpha: float) -> None:
        return self.dll.AUTDGainHoloSDPAlpha(holo, alpha)

    def gain_holo_sdp_lambda(self, holo: ctypes.c_void_p, lambda_: float) -> None:
        return self.dll.AUTDGainHoloSDPLambda(holo, lambda_)

    def gain_holo_sdp_repeat(self, holo: ctypes.c_void_p, repeat: int) -> None:
        return self.dll.AUTDGainHoloSDPRepeat(holo, repeat)

    def gain_holo_sdp_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloSDPAdd(holo, x, y, z, amp)

    def gain_holo_sdp_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloSDPSetDotCareConstraint(holo)

    def gain_holo_sdp_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloSDPSetNormalizeConstraint(holo)

    def gain_holo_sdp_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloSDPSetUniformConstraint(holo, value)

    def gain_holo_sdp_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloSDPSetClampConstraint(holo, min, max)

    def gain_holo_evp(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloEVP(backend)

    def gain_holo_evp_gamma(self, holo: ctypes.c_void_p, gamma: float) -> None:
        return self.dll.AUTDGainHoloEVPGamma(holo, gamma)

    def gain_holo_evp_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloEVPAdd(holo, x, y, z, amp)

    def gain_holo_evp_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloEVPSetDotCareConstraint(holo)

    def gain_holo_evp_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloEVPSetNormalizeConstraint(holo)

    def gain_holo_evp_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloEVPSetUniformConstraint(holo, value)

    def gain_holo_evp_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloEVPSetClampConstraint(holo, min, max)

    def gain_holo_gs(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloGS(backend)

    def gain_holo_gs_repeat(self, holo: ctypes.c_void_p, repeat: int) -> None:
        return self.dll.AUTDGainHoloGSRepeat(holo, repeat)

    def gain_holo_gs_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloGSAdd(holo, x, y, z, amp)

    def gain_holo_gs_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGSSetDotCareConstraint(holo)

    def gain_holo_gs_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGSSetNormalizeConstraint(holo)

    def gain_holo_gs_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloGSSetUniformConstraint(holo, value)

    def gain_holo_gs_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloGSSetClampConstraint(holo, min, max)

    def gain_holo_gspat(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloGSPAT(backend)

    def gain_holo_gspat_repeat(self, holo: ctypes.c_void_p, repeat: int) -> None:
        return self.dll.AUTDGainHoloGSPATRepeat(holo, repeat)

    def gain_holo_gspat_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloGSPATAdd(holo, x, y, z, amp)

    def gain_holo_gspat_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGSPATSetDotCareConstraint(holo)

    def gain_holo_gspat_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGSPATSetNormalizeConstraint(holo)

    def gain_holo_gspat_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloGSPATSetUniformConstraint(holo, value)

    def gain_holo_gspat_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloGSPATSetClampConstraint(holo, min, max)

    def gain_holo_naive(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloNaive(backend)

    def gain_holo_naive_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloNaiveAdd(holo, x, y, z, amp)

    def gain_holo_naive_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloNaiveSetDotCareConstraint(holo)

    def gain_holo_naive_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloNaiveSetNormalizeConstraint(holo)

    def gain_holo_naive_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloNaiveSetUniformConstraint(holo, value)

    def gain_holo_naive_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloNaiveSetClampConstraint(holo, min, max)

    def gain_holo_greedy(self) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloGreedy()

    def gain_holo_greedy_phase_div(self, holo: ctypes.c_void_p, div: int) -> None:
        return self.dll.AUTDGainHoloGreedyPhaseDiv(holo, div)

    def gain_holo_greedy_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloGreedyAdd(holo, x, y, z, amp)

    def gain_holo_greedy_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGreedySetDotCareConstraint(holo)

    def gain_holo_greedy_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloGreedySetNormalizeConstraint(holo)

    def gain_holo_greedy_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloGreedySetUniformConstraint(holo, value)

    def gain_holo_greedy_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloGreedySetClampConstraint(holo, min, max)

    def gain_holo_lm(self, backend: ctypes.c_void_p) -> ctypes.c_void_p:
        return self.dll.AUTDGainHoloLM(backend)

    def gain_holo_lm_eps_1(self, holo: ctypes.c_void_p, eps_1: float) -> None:
        return self.dll.AUTDGainHoloLMEps1(holo, eps_1)

    def gain_holo_lm_eps_2(self, holo: ctypes.c_void_p, eps_2: float) -> None:
        return self.dll.AUTDGainHoloLMEps2(holo, eps_2)

    def gain_holo_lm_tau(self, holo: ctypes.c_void_p, tau: float) -> None:
        return self.dll.AUTDGainHoloLMTau(holo, tau)

    def gain_holo_lmk_max(self, holo: ctypes.c_void_p, k_max: int) -> None:
        return self.dll.AUTDGainHoloLMKMax(holo, k_max)

    def gain_holo_lm_initial(self, holo: ctypes.c_void_p, ptr: Any, len: int) -> None:
        return self.dll.AUTDGainHoloLMInitial(holo, ptr, len)

    def gain_holo_lm_add(self, holo: ctypes.c_void_p, x: float, y: float, z: float, amp: float) -> None:
        return self.dll.AUTDGainHoloLMAdd(holo, x, y, z, amp)

    def gain_holo_lm_set_dot_care_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloLMSetDotCareConstraint(holo)

    def gain_holo_lm_set_normalize_constraint(self, holo: ctypes.c_void_p) -> None:
        return self.dll.AUTDGainHoloLMSetNormalizeConstraint(holo)

    def gain_holo_lm_set_uniform_constraint(self, holo: ctypes.c_void_p, value: float) -> None:
        return self.dll.AUTDGainHoloLMSetUniformConstraint(holo, value)

    def gain_holo_lm_set_clamp_constraint(self, holo: ctypes.c_void_p, min: float, max: float) -> None:
        return self.dll.AUTDGainHoloLMSetClampConstraint(holo, min, max)
